CR CR
.(       -=HI RES PACKAGE=-    )
CR CR .( COMPILING...) CR
.( HR DRIVERS )

( Dummy Display Buffer )
HEX HERE DUP  ( -- LBUF LBUF)
4FED ,       ( ld r,a          )
0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
C0 C,        ( ret nz          )

( HR Video Driver )
HERE SWAP ( -- LBUF HR LBUF )
A6 C,        ( HR    and [hl]  )
0706 ,       (       ld b,7    )
FE10 ,       (       djnz $    )
05 C,        (       dec b     )
21 C, A000 , (       ld hl,A000)
11 C, 0020 , (       ld de,20  )
C006 ,       (       ld b,C0   )
HERE SWAP ( -- LBUF HR HR1 LBUF)
7C C,        ( HR1   ld a,h    )
47ED ,       (       ld i,a    )
7D C,        (       ld a,l    )
CD C, 8000 + , ( call LBUF+8000)
19 C,        (       add hl,de )
05 C,        (       dec b     )
C2 C, ,      (       jp nz,HR1 )
CD C, 292 ,  (       call 292  )
CD C, 220 ,  (       call 220  )
DUP ( -- LBUF HR HR )
21DD , ,     (      ld ix,HR   )
C3 C, 2A4 ,  (      JP 2A4     )

.( OK) CR .( HGR )
CODE HGR
C5 C,         ( push bc        )
21 C, B800 ,  ( ld hl,FP_Bits  )
0806 ,        ( ld b,8         )
803E ,        ( ld a,80        )
77 C,         ( ld [hl],a      )
23 C,         ( inc hl         )
3FCB ,        ( srl a          )
FA10 ,        ( djnz -6        )
21DD , ,      ( ld ix,HR       )
C1 C,         ( pop bc         )
NEXT

.( OK) CR .( TEXT )
CODE TEXT
1E3E ,       (  ld a,1E        )
47ED ,       (  ld i,a         )
21DD , 281 , (  ld ix,281      )
NEXT

.( OK) CR .( GINVERT )
2+  ( -- LBUF+2 )
CODE GINVERT  ( -- )
C5 C,      (      puch bc      )
21 C, ,    (      ld hl,LBUF+2 )
2006 ,     (      ld b,$20     )
803E ,     ( invc ld a,$80     )
AE C,      (      xor [hl]     )
77 C,      (      ld [hl],a    )
23 C,      (      inc hl       )
F910 ,     (      djnz invc    )
C1 C,      (      pop bc       )
NEXT

.( OK) CR .( GPAGE )
HERE 0 ,  ( -- HGRADD )
CODE GPAGE
D9 C,         ( exx            )
21 C, A000 ,  ( ld hl,A000     )
11 C, A001 ,  ( ld de,A001     )
01 C, 17FF ,  ( ld bc,17FF     )
22 C,  ,      ( ld [HGRADD],hl )
AF C,         ( xor a          )
77 C,         ( ld [hl],a      )
B0ED ,        ( ldir           )
D9 C,         ( exx            )
NEXT

.( OK) CR .( PIXEL ADDR ROUTINE)
( HL=x, BC=y                   )
( Returns HL=address, A=pixel  )
( Sets carry if pixel out of   )
( range on map                 )
HERE 0 , 0 ,  ( -- coords )
HERE ( -- coords PADDR)
SWAP DUP DUP
43ED , ,     ( ld [coords],bc  ) 
22 C, 2+ ,   ( ld [coords+2],hl)
78 C,        ( ld a,b          )
B4 C,        ( or h            )
37 C,        ( scf             )
C0 C,        ( ret nz          )
79 C,        ( ld a,c          )
C0FE ,       ( cp 192          )
3F C,        ( ccf             )
D8 C,        ( ret c           )
BF3E ,       ( ld a,191        )
91 C,        ( sub c           )
67 C,        ( ld h,a          )
7D C,        ( ld a,l          )
07E6 ,       ( and $07         )
4F C,        ( ld c,a          )
3CCB ,       ( srl h           )
1DCB ,       ( rr l            )
3CCB ,       ( srl h           )
1DCB ,       ( rr l            )
3CCB ,       ( srl h           )
1DCB ,       ( rr l            )
A03E ,       ( ld a,$a0        )
B4 C,        ( or h            )
67 C,        ( ld h,a          )
B806 ,       ( ld b,FP_Bits/256)
0A C,        ( ld a,[bc]       )
C9 C,        ( ret             )

.(  OK) CR .( DRAW LINE ROUTINE)
( across HL=X, up BC=Y         )
( Based on graphics routines   )
( from Z88 CamelForth by Garry )
( Lancaster.                   )
HERE SWAP ( -- PADDR drawline  )
          (    coords          )
78 C,     (      ld a,b        )
07 C,     (      rlca          )
79 C,     (      ld a,c        )
0116 ,    (      ld d,1        )
0430 ,    (      jr nc,gline1  )
44ED ,    (      neg           )
FF16 ,    (      ld d,-1       )
47 C,     (  gline1  ld b,a    )
79 C,     (      ld a,c        )
A7 C,     (      and a         )
0220 ,    (      jr nz,glin1a  )
0016 ,    (      ld d,0        )
7C C,     (  glin1a  ld a,h    )
07 C,     (      rlca          )
7D C,     (      ld a,l        )
011E ,    (      ld e,1        )
0430 ,    (      jr nc,gline2  )
44ED ,    (      neg           )
FF1E ,    (      ld e,-1       )
4F C,     (  gline2  ld c,a    )
7D C,     (      ld a,l        )
A7 C,     (      and a         )
0220 ,    (      jr nz,glin2a  )
001E ,    (      ld e,0        )
79 C,     (  glin2a  ld a,c    )
B8 C,     (      cp b          )
0630 ,    (      jr nc,gline3  )
69 C,     (      ld l,c        )
D5 C,     (      push de       )
001E ,    (      ld e,0        )
0718 ,    (      jr gline4     )
B0 C,     (  gline3  or b      )
C8 C,     (      ret z         )
68 C,     (      ld l,b        )
41 C,     (      ld b,c        )
D5 C,     (      push de       )
0016 ,    (      ld d,0        )
60 C,     (  gline4  ld h,b    )
78 C,     (      ld a,b        )
3FCB ,    (      srl a         )
85 C,     (  gline5  add a,l   )
0338 ,    (      jr c,gline6   )
BC C,     (      cp h          )
0738 ,    (      jr c,gline7   )
94 C,     (  gline6  sub h     )
4F C,     (      ld c,a        )
D9 C,     (      exx           )
C1 C,     (      pop bc        )
C5 C,     (      push bc       )
0418 ,    (      jr gline8     )
4F C,     (  gline7  ld c,a    )
D5 C,     (      push de       )
D9 C,     (      exx           )
C1 C,     (      pop bc        )
          (  gline8            )
2A C, DUP , (    ld hl,[coords])
50 C,     (      ld d,b        )
15 C,     (      dec d         )
0128 ,    (      jr z,glinec   )
14 C,     (      inc d         )
58 C,     (  glinec  ld e,b    )
19 C,     (      add hl,de     )
51 C,     (      ld d,c        )
15 C,     (      dec d         )
0128 ,    (      jr z,glined   )
14 C,     (      inc d         )
59 C,     (  glined  ld e,c    )
44 C,     (      ld b,h        )
4D C,     (      ld c,l        )
2A C,
DUP 2+ ,  (   ld hl,[coords+2] )
19 C,     (      add hl,de     )
CD C, ROT DUP , ( call PADDR   )
0338 ,    (      jr c,glinea   )
HERE ( -- drawline coords PADDR)
     (    drwmod               )
00 C,     (  drwmod  nop       )
B6 C,     (      or [hl]       )
77 C,     (      ld [hl],a     )
D9 C,     (  glinea  exx       )
79 C,     (      ld a,c        )
CD10 ,    (      djnz gline5   )
D1 C,     (      pop de        )
C9 C,     (      ret           )

.(  OK) CR .( GPIX )
( Plot pixel at [x,y]          )
CODE GPIX  ( x y -- )
E1 C,        (   pop hl        )
CD C, OVER , (   call PADDR    )
0338 ,       (   jr c,GS1      )
HERE ( -- drawline coords PADDR)
     (    drwmod setmod        )
00 C,    (  setmod  nop        )
B6 C,        (   or [hl]       )
77 C,        (   ld [hl],a     )
C1 C,    (  GS1  pop bc        )
NEXT

.( OK) CR .( PMODE )
( Set behavior of GPIX and DRAW)
(  0 = Reset                   )
(  1 = Set                     )
(  2 = Invert                  )
CODE PMODE  ( n -- )
21 C, B600 ,   ( ld hl,$B600   )
    (   00,B6 = 'nop / or [hl]')
0D C,          ( dec c         )
0928 ,         ( jr z,ink1     )
21 C, AE00 ,   ( ld hl,$AE00   )
    (  00,AE = 'nop / xor [hl]')
0D C,          ( dec c         )
0328 ,         ( jr z,ink1     )
21 C, A62F ,   ( ld hl,$A62F   )
    (  2F,A6 = 'cpl / and [hl]')
22 C, ,   ( ink1 ld [setmod],hl)
22 C, ,        ( ld [drwmod],hl)
C1 C,          ( pop bc        )
NEXT

.( OK) CR .( GSET? )
( Test if pixel at [x,y] is set)
( -- drawline coords PADDR)
CODE GSET?  ( x y -- flag)
E1 C,          ( pop hl        )
CD C, ,        ( call PADDR    )
0006 ,         ( ld b,0        )
0438 ,         ( jr c,gstq1    )
A6 C,          ( and [hl]      )
0128 ,         ( jr z,gstq1    )
05 C,          ( dec b         )
48 C,      ( gstq1   ld c,b    )
NEXT

.( OK) CR .( GMOVE )
( Move plot position to [x,y]  )
CODE GMOVE  ( x y -- )
E1 C,          ( pop hl        )
43ED , DUP ,   ( ld [coords],bc)
22 C,        ( ld [coords+2],hl)
DUP 2+ ,
C1 C,          ( pop bc        )
NEXT

.( OK) CR .( GPOS? )
( Get plot position            )
CODE GPOS?  ( -- x y )
C5 C,           ( push bc      )
2A C,        ( ld hl,[coords+2])
DUP 2+ ,
E5 C,           ( push hl      )
4BED , DUP ,   ( ld bc,[coords])
NEXT

.( OK ) CR .( GLINE )
( Draw line from last plot     )
( across dx, up dy             )
CODE GLINE  ( dx dy -- )
E1 C,       (    pop hl        )
D5 C,       (    push de       )
HERE ROT
( -- coords drw1 drawline)
CD C, ,    ( drw1 call drawline)
D1 C,       (    pop de        )
C1 C,       (    pop bc        )
NEXT

.( OK) CR .( GLINETO )
( Draw line from last pos TO   )
( [x,y]                        )
CODE GLINETO  ( x y -- )
60 C,           ( ld h,b       )
69 C,           ( ld l,c       )
4BED , OVER ,  ( ld bc,[coords])
B7 C,           ( or a         )
42ED ,          ( sbc hl,bc    )
44 C,           ( ld b,h       )
4D C,           ( ld c,l       )
EB C,           ( ex de,hl     )
E3 C,           ( ex [sp],hl   )
5BED , SWAP  ( ld de,[coords+2])
2+ ,
B7 C,            ( or a        )
52ED ,           ( sbc hl,de   )
C3 C, ,          ( jp drw1     )

.( OK) CR CR
.( COMPILATION COMPLETED!) CR CR
DECIMAL

;S
